;SendSPI Macro
;         mvf     SSPBUF,F,ACCE
;endm;
;
;ReadSPI Macro
;         mvf     SSPBUF,W,ACCE
;endm
;
;InitSPI Macro
;         BCF     PT1O,0,ACCE
;endm;
;
;EndSPI  Macro          
;         BSF     PT1O,0,ACCE                   
;endm
;===================================          
;======================================================
;==========================================================
TBufEmpty:
         mvf     RAMStart,W,ACCE
         subf    RAMClient,W,ACCE
         ret         
;==========================================================
; SPI
RDIncFlashAddr:
        lbsr     FlashAddr
        mvl      1
        addf     FlashAddr,F,BANK
        mvl      0
        addc     FlashAddr+1,F,BANK
        addc     FlashAddr+2,F,BANK
        ret
;==========================================================
RdFlash:
        lbsr    FlashAddr
        LDPR    SaveData,FSR0
     RdFlashAloop:   
        CALL    InitSPI
        mvl     03h
        call    SendWaitSPI
        call    WRFlashADDR
     RdFlashLoop:   
        call    ReadSPI
        mvf     FlashData,W,BANK
        mvf     POINC0,F,ACCE
        dcsz    FlashLen,F,BANK
        jmp     RdFlashA1
        call    WrIncFlashAddr
        CALL    EndSPI
        ret
   RdFlashA1:
        call    WrIncFlashAddr
        btss    status,c,acce
        jmp     RdFlashLoop
        CALL    EndSPI
        jmp     RdFlashAloop      
;==========================================================
WRFlash:
       lbsr     FlashAddr
        mvl     0h
        subf    FlashAddr,W,BANK
        mvl     0h
        subc    FlashAddr+1,W,BANK
        mvl     08h
        subc    FlashAddr+2,W,BANK
        btsz    Status,C,ACCE
        retl   2
        call    TBufEmpty
        btsz    status,z,ACCE
        retl   0
        tfsz    FlashAddr,BANK
        jmp     WRFlashLoop
        call    WRFlashEnable
        call    RDFlashSta
        andl    00000001b
        btss    status,z,ACCE
        retl   0
        call    RDFlashSta
        andl    00000010b
        btsz    status,z,ACCE
        retl   0
        
        CALL    InitSPI
        mvl     02h
        call    SendWaitSPI
        call    WRFlashADDR
    WRFlashLoop:    
        mvf     RAMStart,W,ACCE
        mvf     FSR0L,F,ACCE
        mvl     High  SaveData
        mvf     FSR0H,F,ACCE
        mvf     INDF0,W,ACCE
        call    SendWaitSPI
        inf     RAMStart,F,ACCE
        mvl     LOW  SaveData
        subf    RAMStart,W,ACCE
        addl    256 - SaveDataend + SaveData - 1
        btss    status,c,ACCE
        jmp     WRFlashLoop1
        mvl     LOW  SaveData       ; pG RAMStartWL6Fh h20h}l
        mvf     RAMStart,F,ACCE
     WRFlashLoop1:   
        call    WrIncFlashAddr
        btsz    status,c,ACCE
        jmp     WRFlashReady
        call    TBufEmpty
        btss    status,z,ACCE
        jmp     WRFlashLoop
    WRFlashEnd:    
        ;CALL    EndSPI
        retl   0
WRFlashReady:
        CALL    EndSPI
        jmp     WRFlash
;==============================        
WrIncFlashAddr:
        lbsr    FlashAddr
        bcf     Status,c,ACCE
        insz    FlashAddr,F,BANK
        ret
        mvl     1
        rrfc     WREG,F,ACCE
        insz    FlashAddr+1,F,BANK
        ret
        insz    FlashAddr+2,F,BANK
        ret
        ret        
;---------------------------        
WRFlashADDR:
        lbsr    FlashAddr
        mvf     FlashAddr+2,W,BANK
        call    SendWaitSPI
        mvf     FlashAddr+1,W,BANK
        call    SendWaitSPI
        mvf     FlashAddr,W,BANK
        jmp     SendWaitSPI
;---------------------------        
RDFlashSta:
        CALL    InitSPI
        mvl     05h
        call    SendWaitSPI
       ; mvl    0FFh
        call    ReadSPI
        CALL    EndSPI
        mvf     FlashData,W,BANK
        ret
;---------------------------        
WRFlashEnable:        
        CALL    InitSPI
        mvl     06h
        call    SendWaitSPI
        CALL    EndSPI
        ret
        
;---------------------------        
FlashErease:
        Call    WRFlashEnable
     FlashErease1:              
        call    RDFlashSta
        andl    00000001b
        btss    status,z,ACCE
        jmp     FlashErease1
        CALL    InitSPI
        mvl     0C7h
        call    SendWaitSPI
        CALL    EndSPI
     FlashErease2:              
        call    RDFlashSta
        andl    00000001b
        btss    status,z,ACCE
        jmp     FlashErease2
        ret
;---------------------------        
;WRFlashSta:        
;        CALL    InitSPI
;        mvl     01h
;        call    SendWaitSPI
;        mvf     FlashSta,W,ACCE
;        call    SendWaitSPI
;        CALL    EndSPI
;        ret
;---------------------------
SendWaitSPI:
       ; 1
        rlfc   WREG,F,ACCE      
        btss   STATUS,C,ACCE
        bcf    FSPIDI,bSPIDI,ACCE
        btsz   STATUS,C,ACCE
        bsf    FSPIDI,bSPIDI,ACCE       
        bsf    FSPICK,bSPICK,ACCE
        NOP
        NOP
        bcf    FSPICK,bSPICK,ACCE
       ; 2
        rlfc   WREG,F,ACCE      
        btss   STATUS,C,ACCE
        bcf    FSPIDI,bSPIDI,ACCE
        btsz   STATUS,C,ACCE
        bsf    FSPIDI,bSPIDI,ACCE       
        bsf    FSPICK,bSPICK,ACCE
        NOP
        NOP
        bcf    FSPICK,bSPICK,ACCE
       ; 3
        rlfc   WREG,F,ACCE      
        btss   STATUS,C,ACCE
        bcf    FSPIDI,bSPIDI,ACCE
        btsz   STATUS,C,ACCE
        bsf    FSPIDI,bSPIDI,ACCE       
        bsf    FSPICK,bSPICK,ACCE
        NOP
        NOP
        bcf    FSPICK,bSPICK,ACCE
       ; 4
        rlfc   WREG,F,ACCE      
        btss   STATUS,C,ACCE
        bcf    FSPIDI,bSPIDI,ACCE
        btsz   STATUS,C,ACCE
        bsf    FSPIDI,bSPIDI,ACCE       
        bsf    FSPICK,bSPICK,ACCE
        NOP
        NOP
        bcf    FSPICK,bSPICK,ACCE
       ; 5
        rlfc   WREG,F,ACCE      
        btss   STATUS,C,ACCE
        bcf    FSPIDI,bSPIDI,ACCE
        btsz   STATUS,C,ACCE
        bsf    FSPIDI,bSPIDI,ACCE       
        bsf    FSPICK,bSPICK,ACCE
        NOP
        NOP
        bcf    FSPICK,bSPICK,ACCE
       ; 6
        rlfc   WREG,F,ACCE      
        btss   STATUS,C,ACCE
        bcf    FSPIDI,bSPIDI,ACCE
        btsz   STATUS,C,ACCE
        bsf    FSPIDI,bSPIDI,ACCE       
        bsf    FSPICK,bSPICK,ACCE
        NOP
        NOP
        bcf    FSPICK,bSPICK,ACCE
       ; 7
        rlfc   WREG,F,ACCE      
        btss   STATUS,C,ACCE
        bcf    FSPIDI,bSPIDI,ACCE
        btsz   STATUS,C,ACCE
        bsf    FSPIDI,bSPIDI,ACCE       
        bsf    FSPICK,bSPICK,ACCE
        NOP
        NOP
        bcf    FSPICK,bSPICK,ACCE
       ; 8
        rlfc   WREG,F,ACCE      
        btss   STATUS,C,ACCE
        bcf    FSPIDI,bSPIDI,ACCE
        btsz   STATUS,C,ACCE
        bsf    FSPIDI,bSPIDI,ACCE       
        bsf    FSPICK,bSPICK,ACCE
        NOP
        NOP
        bcf    FSPICK,bSPICK,ACCE
        RET
;======================================
InitSPI:
         BSF     FSPICS,bSPICS,ACCE
         BCF     FSPICK,bSPICK,ACCE
         BCF     FSPIDI,bSPIDI,ACCE
         BCF     FSPICS,bSPICS,ACCE
         NOP
         RET
;======================================
ReadSPI:
         lbsr    FlashData
        ; 1 
         bsf    FSPICK,bSPICK,ACCE
         MVL     0
         btsz   FSPIDO,bSPIDO,ACCE
         MVL     1
         rrfc    WREG,F,ACCE
         rlfc    FlashData,F,BANK
         bcf    FSPICK,bSPICK,ACCE
         nop
         nop
        ; 2 
         bsf    FSPICK,bSPICK,ACCE
         MVL     0
         btsz   FSPIDO,bSPIDO,ACCE
         MVL     1
         rrfc    WREG,F,ACCE
         rlfc    FlashData,F,BANK
         bcf    FSPICK,bSPICK,ACCE
         nop
         nop
        ; 3 
         bsf    FSPICK,bSPICK,ACCE
         MVL     0
         btsz   FSPIDO,bSPIDO,ACCE
         MVL     1
         rrfc    WREG,F,ACCE
         rlfc    FlashData,F,BANK
         bcf    FSPICK,bSPICK,ACCE
         nop
         nop
        ; 4 
         bsf    FSPICK,bSPICK,ACCE
         MVL     0
         btsz   FSPIDO,bSPIDO,ACCE
         MVL     1
         rrfc    WREG,F,ACCE
         rlfc    FlashData,F,BANK
         bcf    FSPICK,bSPICK,ACCE
         nop
         nop
        ; 5 
         bsf    FSPICK,bSPICK,ACCE
         MVL     0
         btsz   FSPIDO,bSPIDO,ACCE
         MVL     1
         rrfc    WREG,F,ACCE
         rlfc    FlashData,F,BANK
         bcf    FSPICK,bSPICK,ACCE
         nop
         nop
        ; 6 
         bsf    FSPICK,bSPICK,ACCE
         MVL     0
         btsz   FSPIDO,bSPIDO,ACCE
         MVL     1
         rrfc    WREG,F,ACCE
         rlfc    FlashData,F,BANK
         bcf    FSPICK,bSPICK,ACCE
         nop
         nop
        ; 7 
         bsf    FSPICK,bSPICK,ACCE
         MVL     0
         btsz   FSPIDO,bSPIDO,ACCE
         MVL     1
         rrfc    WREG,F,ACCE
         rlfc    FlashData,F,BANK
         bcf    FSPICK,bSPICK,ACCE
         nop
         nop
        ; 8 
         bsf    FSPICK,bSPICK,ACCE
         MVL     0
         btsz   FSPIDO,bSPIDO,ACCE
         MVL     1
         rrfc    WREG,F,ACCE
         rlfc    FlashData,F,BANK
         bcf    FSPICK,bSPICK,ACCE
         ret
;======================================
EndSPI:
         BSF     FSPICS,bSPICS,ACCE
         BCF     FSPICK,bSPICK,ACCE
         BCF     FSPIDI,bSPIDI,ACCE
         RET
;=======================================
Beep:
	bsf	PT1M2,6,ACCE
	call	Delay100ms
	bcf	PT1M2,6,ACCE
	ret	         